git-revert.shon commit Use merge-recursive in git-revert/git-cherry-pick (acb4441)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Linus Torvalds
   4# Copyright (c) 2005 Junio C Hamano
   5#
   6
   7case "$0" in
   8*-revert* )
   9        test -t 0 && edit=-e
  10        replay=
  11        me=revert
  12        USAGE='[--edit | --no-edit] [-n] <commit-ish>' ;;
  13*-cherry-pick* )
  14        replay=t
  15        edit=
  16        me=cherry-pick
  17        USAGE='[--edit] [-n] [-r] [-x] <commit-ish>'  ;;
  18* )
  19        echo >&2 "What are you talking about?"
  20        exit 1 ;;
  21esac
  22
  23SUBDIRECTORY_OK=Yes ;# we will cd up
  24. git-sh-setup
  25require_work_tree
  26cd_to_toplevel
  27
  28no_commit=
  29while case "$#" in 0) break ;; esac
  30do
  31        case "$1" in
  32        -n|--n|--no|--no-|--no-c|--no-co|--no-com|--no-comm|\
  33            --no-commi|--no-commit)
  34                no_commit=t
  35                ;;
  36        -e|--e|--ed|--edi|--edit)
  37                edit=-e
  38                ;;
  39        --n|--no|--no-|--no-e|--no-ed|--no-edi|--no-edit)
  40                edit=
  41                ;;
  42        -r)
  43                : no-op ;;
  44        -x|--i-really-want-to-expose-my-private-commit-object-name)
  45                replay=
  46                ;;
  47        -*)
  48                usage
  49                ;;
  50        *)
  51                break
  52                ;;
  53        esac
  54        shift
  55done
  56
  57test "$me,$replay" = "revert,t" && usage
  58
  59case "$no_commit" in
  60t)
  61        # We do not intend to commit immediately.  We just want to
  62        # merge the differences in.
  63        head=$(git-write-tree) ||
  64                die "Your index file is unmerged."
  65        ;;
  66*)
  67        head=$(git-rev-parse --verify HEAD) ||
  68                die "You do not have a valid HEAD"
  69        files=$(git-diff-index --cached --name-only $head) || exit
  70        if [ "$files" ]; then
  71                die "Dirty index: cannot $me (dirty: $files)"
  72        fi
  73        ;;
  74esac
  75
  76rev=$(git-rev-parse --verify "$@") &&
  77commit=$(git-rev-parse --verify "$rev^0") ||
  78        die "Not a single commit $@"
  79prev=$(git-rev-parse --verify "$commit^1" 2>/dev/null) ||
  80        die "Cannot run $me a root commit"
  81git-rev-parse --verify "$commit^2" >/dev/null 2>&1 &&
  82        die "Cannot run $me a multi-parent commit."
  83
  84encoding=$(git repo-config i18n.commitencoding || echo UTF-8)
  85
  86# "commit" is an existing commit.  We would want to apply
  87# the difference it introduces since its first parent "prev"
  88# on top of the current HEAD if we are cherry-pick.  Or the
  89# reverse of it if we are revert.
  90
  91case "$me" in
  92revert)
  93        git show -s --pretty=oneline --encoding="$encoding" $commit |
  94        sed -e '
  95                s/^[^ ]* /Revert "/
  96                s/$/"/
  97        '
  98        echo
  99        echo "This reverts commit $commit."
 100        test "$rev" = "$commit" ||
 101        echo "(original 'git revert' arguments: $@)"
 102        base=$commit next=$prev
 103        ;;
 104
 105cherry-pick)
 106        pick_author_script='
 107        /^author /{
 108                s/'\''/'\''\\'\'\''/g
 109                h
 110                s/^author \([^<]*\) <[^>]*> .*$/\1/
 111                s/'\''/'\''\'\'\''/g
 112                s/.*/GIT_AUTHOR_NAME='\''&'\''/p
 113
 114                g
 115                s/^author [^<]* <\([^>]*\)> .*$/\1/
 116                s/'\''/'\''\'\'\''/g
 117                s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
 118
 119                g
 120                s/^author [^<]* <[^>]*> \(.*\)$/\1/
 121                s/'\''/'\''\'\'\''/g
 122                s/.*/GIT_AUTHOR_DATE='\''&'\''/p
 123
 124                q
 125        }'
 126
 127        logmsg=`git show -s --pretty=raw --encoding="$encoding" "$commit"`
 128        set_author_env=`echo "$logmsg" |
 129        LANG=C LC_ALL=C sed -ne "$pick_author_script"`
 130        eval "$set_author_env"
 131        export GIT_AUTHOR_NAME
 132        export GIT_AUTHOR_EMAIL
 133        export GIT_AUTHOR_DATE
 134
 135        echo "$logmsg" |
 136        sed -e '1,/^$/d' -e 's/^    //'
 137        case "$replay" in
 138        '')
 139                echo "(cherry picked from commit $commit)"
 140                test "$rev" = "$commit" ||
 141                echo "(original 'git cherry-pick' arguments: $@)"
 142                ;;
 143        esac
 144        base=$prev next=$commit
 145        ;;
 146
 147esac >.msg
 148
 149# This three way merge is an interesting one.  We are at
 150# $head, and would want to apply the change between $commit
 151# and $prev on top of us (when reverting), or the change between
 152# $prev and $commit on top of us (when cherry-picking or replaying).
 153
 154git-merge-recursive $base -- $head $next &&
 155result=$(git-write-tree 2>/dev/null) || {
 156        mv -f .msg "$GIT_DIR/MERGE_MSG"
 157        {
 158            echo '
 159Conflicts:
 160'
 161                git ls-files --unmerged |
 162                sed -e 's/^[^   ]*      /       /' |
 163                uniq
 164        } >>"$GIT_DIR/MERGE_MSG"
 165        echo >&2 "Automatic $me failed.  After resolving the conflicts,"
 166        echo >&2 "mark the corrected paths with 'git-add <paths>'"
 167        echo >&2 "and commit the result."
 168        case "$me" in
 169        cherry-pick)
 170                echo >&2 "You may choose to use the following when making"
 171                echo >&2 "the commit:"
 172                echo >&2 "$set_author_env"
 173        esac
 174        exit 1
 175}
 176echo >&2 "Finished one $me."
 177
 178# If we are cherry-pick, and if the merge did not result in
 179# hand-editing, we will hit this commit and inherit the original
 180# author date and name.
 181# If we are revert, or if our cherry-pick results in a hand merge,
 182# we had better say that the current user is responsible for that.
 183
 184case "$no_commit" in
 185'')
 186        git-commit -n -F .msg $edit
 187        rm -f .msg
 188        ;;
 189esac